=== debian/changelog ===
calamari (1.0.0-1) precise; urgency=low

  * New upstream release 

 -- Gary Lowell <glowell@pudgy.ops.newdream.net>  Wed, 30 Oct 2013 21:30:21 -0700

calamari (0.5.1) experimental; urgency=low

  * Beta refresh 1.

 -- Dan Mick <dan.mick@inktank.com>  Fri, 11 Oct 2013 19:31:11 -0700

calamari (0.5) experimental; urgency=low

  * Beta release.

 -- Dan Mick <dan.mick@inktank.com>  Mon, 30 Sep 2013 12:35:21 -0700

calamari (0.1) UNRELEASED; urgency=low

  * Initial release.

 -- Dan Mick <dan.mick@inktank.com>  Tue, 10 Sep 2013 20:37:53 -0700
