=== debian/control ===
Source: calamari
Section: misc
Priority: extra
Homepage: http://www.inktank.com/
Vcs-Browser: https://github.com/ceph/calamari.git
Maintainer: Dan Mick <dan.mick@inktank.com>
Standards-Version: 3.9.3
Build-Depends: debhelper (>= 9),
               git,
               libcairo2-dev,
               libpq-dev,
               lsb-release,
               python-dev,
               python-pip,
               python-virtualenv

Package: calamari-server
Architecture: any
Depends: apache2,
         libapache2-mod-wsgi,
         libcairo2,
         libpq5,
         logrotate,
         postgresql,
         python-cairo,
         salt-master,
         salt-minion,
         supervisor,
         ${misc:Depends},
         ${python:Depends}
Description: Inktank package containing the Calamari management server
 Calamari is a webapp to monitor and control a Ceph cluster via a web
 browser.
